Attribute VB_Name = "basUtil"

' Copyright 1995-2004 ESRI

' All rights reserved under the copyright laws of the United States.

' You may freely redistribute and use this sample code, with or without modification.

' Disclaimer: THE SAMPLE CODE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED 
' WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
' FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ESRI OR 
' CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
' OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
' INTERRUPTION) SUSTAINED BY YOU OR A THIRD PARTY, HOWEVER CAUSED AND ON ANY 
' THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ARISING IN ANY 
' WAY OUT OF THE USE OF THIS SAMPLE CODE, EVEN IF ADVISED OF THE POSSIBILITY OF 
' SUCH DAMAGE.

' For additional information contact: Environmental Systems Research Institute, Inc.

' Attn: Contracts Dept.

' 380 New York Street

' Redlands, California, U.S.A. 92373 

' Email: contracts@esri.com


Option Explicit

Public Const c_sCreFieldPropName As String = "CREATION_FIELDNAME"
Public Const c_sModFieldPropName As String = "MODIFICATION_FIELDNAME"
Public Const c_sUsrFieldPropName As String = "USER_FIELDNAME"
Public Const c_sCreFieldDefaultName As String = "Created"
Public Const c_sModFieldDefaultName As String = "ModifiedLast"
Public Const c_sUsrFieldDefaultName As String = "ModifiedBy"

Public Sub AddTimestampFields(pFieldsEdit As IFieldsEdit)
  
  Dim pFieldEdit As IFieldEdit
  
  ' CREATION FIELD
  Set pFieldEdit = New esriGeoDatabase.Field
  With pFieldEdit
    .Name = c_sCreFieldDefaultName
    .Type = esriFieldTypeDate
  End With
  pFieldsEdit.AddField pFieldEdit
  
  ' MODIFICATION FIELD
  Set pFieldEdit = New esriGeoDatabase.Field
  With pFieldEdit
    .Name = c_sModFieldDefaultName
    .Type = esriFieldTypeDate
  End With
  pFieldsEdit.AddField pFieldEdit

  ' USER FIELD
  Set pFieldEdit = New esriGeoDatabase.Field
  With pFieldEdit
    .Name = c_sUsrFieldDefaultName
    .Type = esriFieldTypeString
    .Length = 50
  End With
  pFieldsEdit.AddField pFieldEdit
End Sub

