/*
 Copyright 1995-2004 ESRI

 All rights reserved under the copyright laws of the United States.

 You may freely redistribute and use this sample code, with or without modification.

 Disclaimer: THE SAMPLE CODE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED 
 WARRANTIES, INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ESRI OR 
 CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 INTERRUPTION) SUSTAINED BY YOU OR A THIRD PARTY, HOWEVER CAUSED AND ON ANY 
 THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ARISING IN ANY 
 WAY OUT OF THE USE OF THIS SAMPLE CODE, EVEN IF ADVISED OF THE POSSIBILITY OF 
 SUCH DAMAGE.

 For additional information contact: Environmental Systems Research Institute, Inc.

 Attn: Contracts Dept.

 380 New York Street

 Redlands, California, U.S.A. 92373 

 Email: contracts@esri.com
*/
// TimestampedFCDescription.h : Declaration of the CTimestampedFCDescription

#ifndef __TIMESTAMPEDFCDESCRIPTION_H_
#define __TIMESTAMPEDFCDESCRIPTION_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CTimestampedFCDescription
class ATL_NO_VTABLE CTimestampedFCDescription : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CTimestampedFCDescription, &CLSID_TimestampedFCDescription>,
	public ITimestampedFCDescription,
	public IFeatureClassDescription,
	public IObjectClassDescription
{
public:
	CTimestampedFCDescription()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_TIMESTAMPEDFCDESCRIPTION)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_CATEGORY_MAP(CTimestampedFCDescription)
	IMPLEMENTED_CATEGORY(__uuidof(CATID_GeoObjectClassDescriptions))
END_CATEGORY_MAP()

BEGIN_COM_MAP(CTimestampedFCDescription)
	COM_INTERFACE_ENTRY(ITimestampedFCDescription)
	COM_INTERFACE_ENTRY(IFeatureClassDescription)
	COM_INTERFACE_ENTRY(IObjectClassDescription)
END_COM_MAP()

public:
// ITimestampedFCDescription
// IObjectClassDescription
	STDMETHOD(get_Name)(BSTR * Name);
	STDMETHOD(get_AliasName)(BSTR * Name);
	STDMETHOD(get_ModelName)(BSTR * Name);
	STDMETHOD(get_ModelNameUnique)(VARIANT_BOOL * IsUnique);
	STDMETHOD(get_InstanceCLSID)(IUID * * InstanceCLSID);
	STDMETHOD(get_ClassExtensionCLSID)(IUID * * ClassExtensionCLSID);
	STDMETHOD(get_RequiredFields)(IFields * * fieldDescription);

// IFeatureClassDescription
	STDMETHOD(get_FeatureType)(esriFeatureType *FeatureType);
	STDMETHOD(get_ShapeFieldName)(BSTR *Name);
};

#endif //__TIMESTAMPEDFCDESCRIPTION_H_
